# Copyright (c) 2007 SIEGE Development Team
# All rights reserved.
#
# This file is part of libSIEGE.
#
# This software is copyrighted work licensed under the terms of the
# 2-clause BSD license. Please consult the file "license.txt" for
# details.
#
# If you did not recieve the file with this program, please email
# Tim Chas <darkuranium@gmail.com>.

from libc.stdint cimport *

cdef extern from "siege/common.h":
    ctypedef void     SGvoid
    ctypedef uint8_t  SGbool
    ctypedef uint32_t SGenum
    
    ctypedef char     SGchar
    ctypedef uint16_t SGwchar
    ctypedef uint32_t SGdchar
    
    ctypedef int8_t   SGbyte
    ctypedef uint8_t  SGubyte
    ctypedef int16_t  SGshort
    ctypedef uint16_t SGushort
    ctypedef int32_t  SGint
    ctypedef uint32_t SGuint
    ctypedef int64_t  SGlong
    ctypedef uint64_t SGulong
    
    enum:
        SG_PHYSICS_SHAPE_SEGMENT = 0x01
        SG_PHYSICS_SHAPE_POLYGON
        SG_PHYSICS_SHAPE_CIRCLE
    
    enum:
        SG_PHYSICS_BODY_PASSIVE = 0x01
        SG_PHYSICS_BODY_NORMAL
        SG_PHYSICS_BODY_SEMISTATIC
        SG_PHYSICS_BODY_STATIC
