/*
    Copyright (c) 2007 SIEGE Development Team
    All rights reserved.

    This file is part of libSIEGE.

    This software is copyrighted work licensed under the terms of the
    2-clause BSD license. Please consult the file "license.txt" for
    details.

    If you did not recieve the file with this program, please email
    Tim Chas <darkuranium@gmail.com>.
*/

#define SG_BUILD_LIBRARY
#include <siege/util/color.h>

#include <stdlib.h>
#include <string.h>
#include <ctype.h>

const size_t _sg_colNum = 652;

const SGubyte _sg_colFlags[] = 
    {
        3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3,
        3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3,
        3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3,
        3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3,
        3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3,
        3, 3, 3, 3, 3, 3, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
        1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
        1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
        1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
        1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
        1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
        1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
        1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
        1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
        1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
        1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
        1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
        1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
        1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
        1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
        1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
        1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
        1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
        1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
        1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
        1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 3, 3, 3, 3, 3,
        3, 3,
        
        /*3, 3, 3, 3, 3,*/ 0
    };

const char* _sg_colNames[] = 
    {
        "snow", "GhostWhite", "WhiteSmoke", "gainsboro", "FloralWhite",
        "OldLace", "linen", "AntiqueWhite", "PapayaWhip", "BlanchedAlmond",
        "bisque", "PeachPuff", "NavajoWhite", "moccasin", "cornsilk",
        "ivory", "LemonChiffon", "seashell", "honeydew", "MintCream",
        "azure", "AliceBlue", "lavender", "LavenderBlush", "MistyRose",
        "white", "black", "DarkSlateGray", "DarkSlateGrey", "DimGray",
        "DimGrey", "SlateGray", "SlateGrey", "LightSlateGray", "LightSlateGrey",
        "LightGrey", "LightGray", "MidnightBlue", "navy", "NavyBlue",
        "CornflowerBlue", "DarkSlateBlue", "SlateBlue", "MediumSlateBlue", "LightSlateBlue",
        "MediumBlue", "RoyalBlue", "blue", "DodgerBlue", "DeepSkyBlue",
        "SkyBlue", "LightSkyBlue", "SteelBlue", "LightSteelBlue", "LightBlue",
        "PowderBlue", "PaleTurquoise", "DarkTurquoise", "MediumTurquoise", "turquoise",
        "cyan", "LightCyan", "CadetBlue", "MediumAquamarine", "aquamarine",
        "DarkGreen", "DarkOliveGreen", "DarkSeaGreen", "SeaGreen", "MediumSeaGreen",
        "LightSeaGreen", "PaleGreen", "SpringGreen", "LawnGreen", "chartreuse",
        "MediumSpringGreen", "GreenYellow", "LimeGreen", "YellowGreen", "ForestGreen",
        "OliveDrab", "DarkKhaki", "khaki", "PaleGoldenrod", "LightGoldenrodYellow",
        "LightYellow", "yellow", "gold", "LightGoldenrod", "goldenrod",
        "DarkGoldenrod", "RosyBrown", "IndianRed", "SaddleBrown", "sienna",
        "peru", "burlywood", "beige", "wheat", "SandyBrown",
        "tan", "chocolate", "firebrick", "brown", "DarkSalmon",
        "salmon", "LightSalmon", "orange", "DarkOrange", "coral",
        "LightCoral", "tomato", "OrangeRed", "red", "HotPink",
        "DeepPink", "pink", "LightPink", "PaleVioletRed", "MediumVioletRed",
        "VioletRed", "magenta", "violet", "plum", "orchid",
        "MediumOrchid", "DarkOrchid", "DarkViolet", "BlueViolet", "MediumPurple",
        "thistle", "snow1", "snow2", "snow3", "snow4",
        "seashell1", "seashell2", "seashell3", "seashell4", "AntiqueWhite1",
        "AntiqueWhite2", "AntiqueWhite3", "AntiqueWhite4", "bisque1", "bisque2",
        "bisque3", "bisque4", "PeachPuff1", "PeachPuff2", "PeachPuff3",
        "PeachPuff4", "NavajoWhite1", "NavajoWhite2", "NavajoWhite3", "NavajoWhite4",
        "LemonChiffon1", "LemonChiffon2", "LemonChiffon3", "LemonChiffon4", "cornsilk1",
        "cornsilk2", "cornsilk3", "cornsilk4", "ivory1", "ivory2",
        "ivory3", "ivory4", "honeydew1", "honeydew2", "honeydew3",
        "honeydew4", "LavenderBlush1", "LavenderBlush2", "LavenderBlush3", "LavenderBlush4",
        "MistyRose1", "MistyRose2", "MistyRose3", "MistyRose4", "azure1",
        "azure2", "azure3", "azure4", "SlateBlue1", "SlateBlue2",
        "SlateBlue3", "SlateBlue4", "RoyalBlue1", "RoyalBlue2", "RoyalBlue3",
        "RoyalBlue4", "blue1", "blue2", "blue3", "blue4",
        "DodgerBlue1", "DodgerBlue2", "DodgerBlue3", "DodgerBlue4", "SteelBlue1",
        "SteelBlue2", "SteelBlue3", "SteelBlue4", "DeepSkyBlue1", "DeepSkyBlue2",
        "DeepSkyBlue3", "DeepSkyBlue4", "SkyBlue1", "SkyBlue2", "SkyBlue3",
        "SkyBlue4", "LightSkyBlue1", "LightSkyBlue2", "LightSkyBlue3", "LightSkyBlue4",
        "SlateGray1", "SlateGray2", "SlateGray3", "SlateGray4", "LightSteelBlue1",
        "LightSteelBlue2", "LightSteelBlue3", "LightSteelBlue4", "LightBlue1", "LightBlue2",
        "LightBlue3", "LightBlue4", "LightCyan1", "LightCyan2", "LightCyan3",
        "LightCyan4", "PaleTurquoise1", "PaleTurquoise2", "PaleTurquoise3", "PaleTurquoise4",
        "CadetBlue1", "CadetBlue2", "CadetBlue3", "CadetBlue4", "turquoise1",
        "turquoise2", "turquoise3", "turquoise4", "cyan1", "cyan2",
        "cyan3", "cyan4", "DarkSlateGray1", "DarkSlateGray2", "DarkSlateGray3",
        "DarkSlateGray4", "aquamarine1", "aquamarine2", "aquamarine3", "aquamarine4",
        "DarkSeaGreen1", "DarkSeaGreen2", "DarkSeaGreen3", "DarkSeaGreen4", "SeaGreen1",
        "SeaGreen2", "SeaGreen3", "SeaGreen4", "PaleGreen1", "PaleGreen2",
        "PaleGreen3", "PaleGreen4", "SpringGreen1", "SpringGreen2", "SpringGreen3",
        "SpringGreen4", "green1", "green2", "green3", "green4",
        "chartreuse1", "chartreuse2", "chartreuse3", "chartreuse4", "OliveDrab1",
        "OliveDrab2", "OliveDrab3", "OliveDrab4", "DarkOliveGreen1", "DarkOliveGreen2",
        "DarkOliveGreen3", "DarkOliveGreen4", "khaki1", "khaki2", "khaki3",
        "khaki4", "LightGoldenrod1", "LightGoldenrod2", "LightGoldenrod3", "LightGoldenrod4",
        "LightYellow1", "LightYellow2", "LightYellow3", "LightYellow4", "yellow1",
        "yellow2", "yellow3", "yellow4", "gold1", "gold2",
        "gold3", "gold4", "goldenrod1", "goldenrod2", "goldenrod3",
        "goldenrod4", "DarkGoldenrod1", "DarkGoldenrod2", "DarkGoldenrod3", "DarkGoldenrod4",
        "RosyBrown1", "RosyBrown2", "RosyBrown3", "RosyBrown4", "IndianRed1",
        "IndianRed2", "IndianRed3", "IndianRed4", "sienna1", "sienna2",
        "sienna3", "sienna4", "burlywood1", "burlywood2", "burlywood3",
        "burlywood4", "wheat1", "wheat2", "wheat3", "wheat4",
        "tan1", "tan2", "tan3", "tan4", "chocolate1",
        "chocolate2", "chocolate3", "chocolate4", "firebrick1", "firebrick2",
        "firebrick3", "firebrick4", "brown1", "brown2", "brown3",
        "brown4", "salmon1", "salmon2", "salmon3", "salmon4",
        "LightSalmon1", "LightSalmon2", "LightSalmon3", "LightSalmon4", "orange1",
        "orange2", "orange3", "orange4", "DarkOrange1", "DarkOrange2",
        "DarkOrange3", "DarkOrange4", "coral1", "coral2", "coral3",
        "coral4", "tomato1", "tomato2", "tomato3", "tomato4",
        "OrangeRed1", "OrangeRed2", "OrangeRed3", "OrangeRed4", "red1",
        "red2", "red3", "red4", "DeepPink1", "DeepPink2",
        "DeepPink3", "DeepPink4", "HotPink1", "HotPink2", "HotPink3",
        "HotPink4", "pink1", "pink2", "pink3", "pink4",
        "LightPink1", "LightPink2", "LightPink3", "LightPink4", "PaleVioletRed1",
        "PaleVioletRed2", "PaleVioletRed3", "PaleVioletRed4", "maroon1", "maroon2",
        "maroon3", "maroon4", "VioletRed1", "VioletRed2", "VioletRed3",
        "VioletRed4", "magenta1", "magenta2", "magenta3", "magenta4",
        "orchid1", "orchid2", "orchid3", "orchid4", "plum1",
        "plum2", "plum3", "plum4", "MediumOrchid1", "MediumOrchid2",
        "MediumOrchid3", "MediumOrchid4", "DarkOrchid1", "DarkOrchid2", "DarkOrchid3",
        "DarkOrchid4", "purple1", "purple2", "purple3", "purple4",
        "MediumPurple1", "MediumPurple2", "MediumPurple3", "MediumPurple4", "thistle1",
        "thistle2", "thistle3", "thistle4", "gray0", "grey0",
        "gray1", "grey1", "gray2", "grey2", "gray3",
        "grey3", "gray4", "grey4", "gray5", "grey5",
        "gray6", "grey6", "gray7", "grey7", "gray8",
        "grey8", "gray9", "grey9", "gray10", "grey10",
        "gray11", "grey11", "gray12", "grey12", "gray13",
        "grey13", "gray14", "grey14", "gray15", "grey15",
        "gray16", "grey16", "gray17", "grey17", "gray18",
        "grey18", "gray19", "grey19", "gray20", "grey20",
        "gray21", "grey21", "gray22", "grey22", "gray23",
        "grey23", "gray24", "grey24", "gray25", "grey25",
        "gray26", "grey26", "gray27", "grey27", "gray28",
        "grey28", "gray29", "grey29", "gray30", "grey30",
        "gray31", "grey31", "gray32", "grey32", "gray33",
        "grey33", "gray34", "grey34", "gray35", "grey35",
        "gray36", "grey36", "gray37", "grey37", "gray38",
        "grey38", "gray39", "grey39", "gray40", "grey40",
        "gray41", "grey41", "gray42", "grey42", "gray43",
        "grey43", "gray44", "grey44", "gray45", "grey45",
        "gray46", "grey46", "gray47", "grey47", "gray48",
        "grey48", "gray49", "grey49", "gray50", "grey50",
        "gray51", "grey51", "gray52", "grey52", "gray53",
        "grey53", "gray54", "grey54", "gray55", "grey55",
        "gray56", "grey56", "gray57", "grey57", "gray58",
        "grey58", "gray59", "grey59", "gray60", "grey60",
        "gray61", "grey61", "gray62", "grey62", "gray63",
        "grey63", "gray64", "grey64", "gray65", "grey65",
        "gray66", "grey66", "gray67", "grey67", "gray68",
        "grey68", "gray69", "grey69", "gray70", "grey70",
        "gray71", "grey71", "gray72", "grey72", "gray73",
        "grey73", "gray74", "grey74", "gray75", "grey75",
        "gray76", "grey76", "gray77", "grey77", "gray78",
        "grey78", "gray79", "grey79", "gray80", "grey80",
        "gray81", "grey81", "gray82", "grey82", "gray83",
        "grey83", "gray84", "grey84", "gray85", "grey85",
        "gray86", "grey86", "gray87", "grey87", "gray88",
        "grey88", "gray89", "grey89", "gray90", "grey90",
        "gray91", "grey91", "gray92", "grey92", "gray93",
        "grey93", "gray94", "grey94", "gray95", "grey95",
        "gray96", "grey96", "gray97", "grey97", "gray98",
        "grey98", "gray99", "grey99", "gray100", "grey100",
        "DarkGrey", "DarkGray", "DarkBlue", "DarkCyan", "DarkMagenta",
        "DarkRed", "LightGreen",

        /*"gray", "grey", "green", "maroon", "purple",*/ NULL
    };

const SGColor _sg_colValues[] =
    {
        {255/255.0, 250/255.0, 250/255.0, 255/255.0}, {248/255.0, 248/255.0, 255/255.0, 255/255.0}, {245/255.0, 245/255.0, 245/255.0, 255/255.0},
        {220/255.0, 220/255.0, 220/255.0, 255/255.0}, {255/255.0, 250/255.0, 240/255.0, 255/255.0}, {253/255.0, 245/255.0, 230/255.0, 255/255.0},
        {250/255.0, 240/255.0, 230/255.0, 255/255.0}, {250/255.0, 235/255.0, 215/255.0, 255/255.0}, {255/255.0, 239/255.0, 213/255.0, 255/255.0},
        {255/255.0, 235/255.0, 205/255.0, 255/255.0}, {255/255.0, 228/255.0, 196/255.0, 255/255.0}, {255/255.0, 218/255.0, 185/255.0, 255/255.0},
        {255/255.0, 222/255.0, 173/255.0, 255/255.0}, {255/255.0, 228/255.0, 181/255.0, 255/255.0}, {255/255.0, 248/255.0, 220/255.0, 255/255.0},
        {255/255.0, 255/255.0, 240/255.0, 255/255.0}, {255/255.0, 250/255.0, 205/255.0, 255/255.0}, {255/255.0, 245/255.0, 238/255.0, 255/255.0},
        {240/255.0, 255/255.0, 240/255.0, 255/255.0}, {245/255.0, 255/255.0, 250/255.0, 255/255.0}, {240/255.0, 255/255.0, 255/255.0, 255/255.0},
        {240/255.0, 248/255.0, 255/255.0, 255/255.0}, {230/255.0, 230/255.0, 250/255.0, 255/255.0}, {255/255.0, 240/255.0, 245/255.0, 255/255.0},
        {255/255.0, 228/255.0, 225/255.0, 255/255.0}, {255/255.0, 255/255.0, 255/255.0, 255/255.0}, {0/255.0, 0/255.0, 0/255.0, 255/255.0},
        {47/255.0, 79/255.0, 79/255.0, 255/255.0}, {47/255.0, 79/255.0, 79/255.0, 255/255.0}, {105/255.0, 105/255.0, 105/255.0, 255/255.0},
        {105/255.0, 105/255.0, 105/255.0, 255/255.0}, {112/255.0, 128/255.0, 144/255.0, 255/255.0}, {112/255.0, 128/255.0, 144/255.0, 255/255.0},
        {119/255.0, 136/255.0, 153/255.0, 255/255.0}, {119/255.0, 136/255.0, 153/255.0, 255/255.0}, {211/255.0, 211/255.0, 211/255.0, 255/255.0},
        {211/255.0, 211/255.0, 211/255.0, 255/255.0}, {25/255.0, 25/255.0, 112/255.0, 255/255.0}, {0/255.0, 0/255.0, 128/255.0, 255/255.0},
        {0/255.0, 0/255.0, 128/255.0, 255/255.0}, {100/255.0, 149/255.0, 237/255.0, 255/255.0}, {72/255.0, 61/255.0, 139/255.0, 255/255.0},
        {106/255.0, 90/255.0, 205/255.0, 255/255.0}, {123/255.0, 104/255.0, 238/255.0, 255/255.0}, {132/255.0, 112/255.0, 255/255.0, 255/255.0},
        {0/255.0, 0/255.0, 205/255.0, 255/255.0}, {65/255.0, 105/255.0, 225/255.0, 255/255.0}, {0/255.0, 0/255.0, 255/255.0, 255/255.0},
        {30/255.0, 144/255.0, 255/255.0, 255/255.0}, {0/255.0, 191/255.0, 255/255.0, 255/255.0}, {135/255.0, 206/255.0, 235/255.0, 255/255.0},
        {135/255.0, 206/255.0, 250/255.0, 255/255.0}, {70/255.0, 130/255.0, 180/255.0, 255/255.0}, {176/255.0, 196/255.0, 222/255.0, 255/255.0},
        {173/255.0, 216/255.0, 230/255.0, 255/255.0}, {176/255.0, 224/255.0, 230/255.0, 255/255.0}, {175/255.0, 238/255.0, 238/255.0, 255/255.0},
        {0/255.0, 206/255.0, 209/255.0, 255/255.0}, {72/255.0, 209/255.0, 204/255.0, 255/255.0}, {64/255.0, 224/255.0, 208/255.0, 255/255.0},
        {0/255.0, 255/255.0, 255/255.0, 255/255.0}, {224/255.0, 255/255.0, 255/255.0, 255/255.0}, {95/255.0, 158/255.0, 160/255.0, 255/255.0},
        {102/255.0, 205/255.0, 170/255.0, 255/255.0}, {127/255.0, 255/255.0, 212/255.0, 255/255.0}, {0/255.0, 100/255.0, 0/255.0, 255/255.0},
        {85/255.0, 107/255.0, 47/255.0, 255/255.0}, {143/255.0, 188/255.0, 143/255.0, 255/255.0}, {46/255.0, 139/255.0, 87/255.0, 255/255.0},
        {60/255.0, 179/255.0, 113/255.0, 255/255.0}, {32/255.0, 178/255.0, 170/255.0, 255/255.0}, {152/255.0, 251/255.0, 152/255.0, 255/255.0},
        {0/255.0, 255/255.0, 127/255.0, 255/255.0}, {124/255.0, 252/255.0, 0/255.0, 255/255.0}, {127/255.0, 255/255.0, 0/255.0, 255/255.0},
        {0/255.0, 250/255.0, 154/255.0, 255/255.0}, {173/255.0, 255/255.0, 47/255.0, 255/255.0}, {50/255.0, 205/255.0, 50/255.0, 255/255.0},
        {154/255.0, 205/255.0, 50/255.0, 255/255.0}, {34/255.0, 139/255.0, 34/255.0, 255/255.0}, {107/255.0, 142/255.0, 35/255.0, 255/255.0},
        {189/255.0, 183/255.0, 107/255.0, 255/255.0}, {240/255.0, 230/255.0, 140/255.0, 255/255.0}, {238/255.0, 232/255.0, 170/255.0, 255/255.0},
        {250/255.0, 250/255.0, 210/255.0, 255/255.0}, {255/255.0, 255/255.0, 224/255.0, 255/255.0}, {255/255.0, 255/255.0, 0/255.0, 255/255.0},
        {255/255.0, 215/255.0, 0/255.0, 255/255.0}, {238/255.0, 221/255.0, 130/255.0, 255/255.0}, {218/255.0, 165/255.0, 32/255.0, 255/255.0},
        {184/255.0, 134/255.0, 11/255.0, 255/255.0}, {188/255.0, 143/255.0, 143/255.0, 255/255.0}, {205/255.0, 92/255.0, 92/255.0, 255/255.0},
        {139/255.0, 69/255.0, 19/255.0, 255/255.0}, {160/255.0, 82/255.0, 45/255.0, 255/255.0}, {205/255.0, 133/255.0, 63/255.0, 255/255.0},
        {222/255.0, 184/255.0, 135/255.0, 255/255.0}, {245/255.0, 245/255.0, 220/255.0, 255/255.0}, {245/255.0, 222/255.0, 179/255.0, 255/255.0},
        {244/255.0, 164/255.0, 96/255.0, 255/255.0}, {210/255.0, 180/255.0, 140/255.0, 255/255.0}, {210/255.0, 105/255.0, 30/255.0, 255/255.0},
        {178/255.0, 34/255.0, 34/255.0, 255/255.0}, {165/255.0, 42/255.0, 42/255.0, 255/255.0}, {233/255.0, 150/255.0, 122/255.0, 255/255.0},
        {250/255.0, 128/255.0, 114/255.0, 255/255.0}, {255/255.0, 160/255.0, 122/255.0, 255/255.0}, {255/255.0, 165/255.0, 0/255.0, 255/255.0},
        {255/255.0, 140/255.0, 0/255.0, 255/255.0}, {255/255.0, 127/255.0, 80/255.0, 255/255.0}, {240/255.0, 128/255.0, 128/255.0, 255/255.0},
        {255/255.0, 99/255.0, 71/255.0, 255/255.0}, {255/255.0, 69/255.0, 0/255.0, 255/255.0}, {255/255.0, 0/255.0, 0/255.0, 255/255.0},
        {255/255.0, 105/255.0, 180/255.0, 255/255.0}, {255/255.0, 20/255.0, 147/255.0, 255/255.0}, {255/255.0, 192/255.0, 203/255.0, 255/255.0},
        {255/255.0, 182/255.0, 193/255.0, 255/255.0}, {219/255.0, 112/255.0, 147/255.0, 255/255.0}, {199/255.0, 21/255.0, 133/255.0, 255/255.0},
        {208/255.0, 32/255.0, 144/255.0, 255/255.0}, {255/255.0, 0/255.0, 255/255.0, 255/255.0}, {238/255.0, 130/255.0, 238/255.0, 255/255.0},
        {221/255.0, 160/255.0, 221/255.0, 255/255.0}, {218/255.0, 112/255.0, 214/255.0, 255/255.0}, {186/255.0, 85/255.0, 211/255.0, 255/255.0},
        {153/255.0, 50/255.0, 204/255.0, 255/255.0}, {148/255.0, 0/255.0, 211/255.0, 255/255.0}, {138/255.0, 43/255.0, 226/255.0, 255/255.0},
        {147/255.0, 112/255.0, 219/255.0, 255/255.0}, {216/255.0, 191/255.0, 216/255.0, 255/255.0}, {255/255.0, 250/255.0, 250/255.0, 255/255.0},
        {238/255.0, 233/255.0, 233/255.0, 255/255.0}, {205/255.0, 201/255.0, 201/255.0, 255/255.0}, {139/255.0, 137/255.0, 137/255.0, 255/255.0},
        {255/255.0, 245/255.0, 238/255.0, 255/255.0}, {238/255.0, 229/255.0, 222/255.0, 255/255.0}, {205/255.0, 197/255.0, 191/255.0, 255/255.0},
        {139/255.0, 134/255.0, 130/255.0, 255/255.0}, {255/255.0, 239/255.0, 219/255.0, 255/255.0}, {238/255.0, 223/255.0, 204/255.0, 255/255.0},
        {205/255.0, 192/255.0, 176/255.0, 255/255.0}, {139/255.0, 131/255.0, 120/255.0, 255/255.0}, {255/255.0, 228/255.0, 196/255.0, 255/255.0},
        {238/255.0, 213/255.0, 183/255.0, 255/255.0}, {205/255.0, 183/255.0, 158/255.0, 255/255.0}, {139/255.0, 125/255.0, 107/255.0, 255/255.0},
        {255/255.0, 218/255.0, 185/255.0, 255/255.0}, {238/255.0, 203/255.0, 173/255.0, 255/255.0}, {205/255.0, 175/255.0, 149/255.0, 255/255.0},
        {139/255.0, 119/255.0, 101/255.0, 255/255.0}, {255/255.0, 222/255.0, 173/255.0, 255/255.0}, {238/255.0, 207/255.0, 161/255.0, 255/255.0},
        {205/255.0, 179/255.0, 139/255.0, 255/255.0}, {139/255.0, 121/255.0, 94/255.0, 255/255.0}, {255/255.0, 250/255.0, 205/255.0, 255/255.0},
        {238/255.0, 233/255.0, 191/255.0, 255/255.0}, {205/255.0, 201/255.0, 165/255.0, 255/255.0}, {139/255.0, 137/255.0, 112/255.0, 255/255.0},
        {255/255.0, 248/255.0, 220/255.0, 255/255.0}, {238/255.0, 232/255.0, 205/255.0, 255/255.0}, {205/255.0, 200/255.0, 177/255.0, 255/255.0},
        {139/255.0, 136/255.0, 120/255.0, 255/255.0}, {255/255.0, 255/255.0, 240/255.0, 255/255.0}, {238/255.0, 238/255.0, 224/255.0, 255/255.0},
        {205/255.0, 205/255.0, 193/255.0, 255/255.0}, {139/255.0, 139/255.0, 131/255.0, 255/255.0}, {240/255.0, 255/255.0, 240/255.0, 255/255.0},
        {224/255.0, 238/255.0, 224/255.0, 255/255.0}, {193/255.0, 205/255.0, 193/255.0, 255/255.0}, {131/255.0, 139/255.0, 131/255.0, 255/255.0},
        {255/255.0, 240/255.0, 245/255.0, 255/255.0}, {238/255.0, 224/255.0, 229/255.0, 255/255.0}, {205/255.0, 193/255.0, 197/255.0, 255/255.0},
        {139/255.0, 131/255.0, 134/255.0, 255/255.0}, {255/255.0, 228/255.0, 225/255.0, 255/255.0}, {238/255.0, 213/255.0, 210/255.0, 255/255.0},
        {205/255.0, 183/255.0, 181/255.0, 255/255.0}, {139/255.0, 125/255.0, 123/255.0, 255/255.0}, {240/255.0, 255/255.0, 255/255.0, 255/255.0},
        {224/255.0, 238/255.0, 238/255.0, 255/255.0}, {193/255.0, 205/255.0, 205/255.0, 255/255.0}, {131/255.0, 139/255.0, 139/255.0, 255/255.0},
        {131/255.0, 111/255.0, 255/255.0, 255/255.0}, {122/255.0, 103/255.0, 238/255.0, 255/255.0}, {105/255.0, 89/255.0, 205/255.0, 255/255.0},
        {71/255.0, 60/255.0, 139/255.0, 255/255.0}, {72/255.0, 118/255.0, 255/255.0, 255/255.0}, {67/255.0, 110/255.0, 238/255.0, 255/255.0},
        {58/255.0, 95/255.0, 205/255.0, 255/255.0}, {39/255.0, 64/255.0, 139/255.0, 255/255.0}, {0/255.0, 0/255.0, 255/255.0, 255/255.0},
        {0/255.0, 0/255.0, 238/255.0, 255/255.0}, {0/255.0, 0/255.0, 205/255.0, 255/255.0}, {0/255.0, 0/255.0, 139/255.0, 255/255.0},
        {30/255.0, 144/255.0, 255/255.0, 255/255.0}, {28/255.0, 134/255.0, 238/255.0, 255/255.0}, {24/255.0, 116/255.0, 205/255.0, 255/255.0},
        {16/255.0, 78/255.0, 139/255.0, 255/255.0}, {99/255.0, 184/255.0, 255/255.0, 255/255.0}, {92/255.0, 172/255.0, 238/255.0, 255/255.0},
        {79/255.0, 148/255.0, 205/255.0, 255/255.0}, {54/255.0, 100/255.0, 139/255.0, 255/255.0}, {0/255.0, 191/255.0, 255/255.0, 255/255.0},
        {0/255.0, 178/255.0, 238/255.0, 255/255.0}, {0/255.0, 154/255.0, 205/255.0, 255/255.0}, {0/255.0, 104/255.0, 139/255.0, 255/255.0},
        {135/255.0, 206/255.0, 255/255.0, 255/255.0}, {126/255.0, 192/255.0, 238/255.0, 255/255.0}, {108/255.0, 166/255.0, 205/255.0, 255/255.0},
        {74/255.0, 112/255.0, 139/255.0, 255/255.0}, {176/255.0, 226/255.0, 255/255.0, 255/255.0}, {164/255.0, 211/255.0, 238/255.0, 255/255.0},
        {141/255.0, 182/255.0, 205/255.0, 255/255.0}, {96/255.0, 123/255.0, 139/255.0, 255/255.0}, {198/255.0, 226/255.0, 255/255.0, 255/255.0},
        {185/255.0, 211/255.0, 238/255.0, 255/255.0}, {159/255.0, 182/255.0, 205/255.0, 255/255.0}, {108/255.0, 123/255.0, 139/255.0, 255/255.0},
        {202/255.0, 225/255.0, 255/255.0, 255/255.0}, {188/255.0, 210/255.0, 238/255.0, 255/255.0}, {162/255.0, 181/255.0, 205/255.0, 255/255.0},
        {110/255.0, 123/255.0, 139/255.0, 255/255.0}, {191/255.0, 239/255.0, 255/255.0, 255/255.0}, {178/255.0, 223/255.0, 238/255.0, 255/255.0},
        {154/255.0, 192/255.0, 205/255.0, 255/255.0}, {104/255.0, 131/255.0, 139/255.0, 255/255.0}, {224/255.0, 255/255.0, 255/255.0, 255/255.0},
        {209/255.0, 238/255.0, 238/255.0, 255/255.0}, {180/255.0, 205/255.0, 205/255.0, 255/255.0}, {122/255.0, 139/255.0, 139/255.0, 255/255.0},
        {187/255.0, 255/255.0, 255/255.0, 255/255.0}, {174/255.0, 238/255.0, 238/255.0, 255/255.0}, {150/255.0, 205/255.0, 205/255.0, 255/255.0},
        {102/255.0, 139/255.0, 139/255.0, 255/255.0}, {152/255.0, 245/255.0, 255/255.0, 255/255.0}, {142/255.0, 229/255.0, 238/255.0, 255/255.0},
        {122/255.0, 197/255.0, 205/255.0, 255/255.0}, {83/255.0, 134/255.0, 139/255.0, 255/255.0}, {0/255.0, 245/255.0, 255/255.0, 255/255.0},
        {0/255.0, 229/255.0, 238/255.0, 255/255.0}, {0/255.0, 197/255.0, 205/255.0, 255/255.0}, {0/255.0, 134/255.0, 139/255.0, 255/255.0},
        {0/255.0, 255/255.0, 255/255.0, 255/255.0}, {0/255.0, 238/255.0, 238/255.0, 255/255.0}, {0/255.0, 205/255.0, 205/255.0, 255/255.0},
        {0/255.0, 139/255.0, 139/255.0, 255/255.0}, {151/255.0, 255/255.0, 255/255.0, 255/255.0}, {141/255.0, 238/255.0, 238/255.0, 255/255.0},
        {121/255.0, 205/255.0, 205/255.0, 255/255.0}, {82/255.0, 139/255.0, 139/255.0, 255/255.0}, {127/255.0, 255/255.0, 212/255.0, 255/255.0},
        {118/255.0, 238/255.0, 198/255.0, 255/255.0}, {102/255.0, 205/255.0, 170/255.0, 255/255.0}, {69/255.0, 139/255.0, 116/255.0, 255/255.0},
        {193/255.0, 255/255.0, 193/255.0, 255/255.0}, {180/255.0, 238/255.0, 180/255.0, 255/255.0}, {155/255.0, 205/255.0, 155/255.0, 255/255.0},
        {105/255.0, 139/255.0, 105/255.0, 255/255.0}, {84/255.0, 255/255.0, 159/255.0, 255/255.0}, {78/255.0, 238/255.0, 148/255.0, 255/255.0},
        {67/255.0, 205/255.0, 128/255.0, 255/255.0}, {46/255.0, 139/255.0, 87/255.0, 255/255.0}, {154/255.0, 255/255.0, 154/255.0, 255/255.0},
        {144/255.0, 238/255.0, 144/255.0, 255/255.0}, {124/255.0, 205/255.0, 124/255.0, 255/255.0}, {84/255.0, 139/255.0, 84/255.0, 255/255.0},
        {0/255.0, 255/255.0, 127/255.0, 255/255.0}, {0/255.0, 238/255.0, 118/255.0, 255/255.0}, {0/255.0, 205/255.0, 102/255.0, 255/255.0},
        {0/255.0, 139/255.0, 69/255.0, 255/255.0}, {0/255.0, 255/255.0, 0/255.0, 255/255.0}, {0/255.0, 238/255.0, 0/255.0, 255/255.0},
        {0/255.0, 205/255.0, 0/255.0, 255/255.0}, {0/255.0, 139/255.0, 0/255.0, 255/255.0}, {127/255.0, 255/255.0, 0/255.0, 255/255.0},
        {118/255.0, 238/255.0, 0/255.0, 255/255.0}, {102/255.0, 205/255.0, 0/255.0, 255/255.0}, {69/255.0, 139/255.0, 0/255.0, 255/255.0},
        {192/255.0, 255/255.0, 62/255.0, 255/255.0}, {179/255.0, 238/255.0, 58/255.0, 255/255.0}, {154/255.0, 205/255.0, 50/255.0, 255/255.0},
        {105/255.0, 139/255.0, 34/255.0, 255/255.0}, {202/255.0, 255/255.0, 112/255.0, 255/255.0}, {188/255.0, 238/255.0, 104/255.0, 255/255.0},
        {162/255.0, 205/255.0, 90/255.0, 255/255.0}, {110/255.0, 139/255.0, 61/255.0, 255/255.0}, {255/255.0, 246/255.0, 143/255.0, 255/255.0},
        {238/255.0, 230/255.0, 133/255.0, 255/255.0}, {205/255.0, 198/255.0, 115/255.0, 255/255.0}, {139/255.0, 134/255.0, 78/255.0, 255/255.0},
        {255/255.0, 236/255.0, 139/255.0, 255/255.0}, {238/255.0, 220/255.0, 130/255.0, 255/255.0}, {205/255.0, 190/255.0, 112/255.0, 255/255.0},
        {139/255.0, 129/255.0, 76/255.0, 255/255.0}, {255/255.0, 255/255.0, 224/255.0, 255/255.0}, {238/255.0, 238/255.0, 209/255.0, 255/255.0},
        {205/255.0, 205/255.0, 180/255.0, 255/255.0}, {139/255.0, 139/255.0, 122/255.0, 255/255.0}, {255/255.0, 255/255.0, 0/255.0, 255/255.0},
        {238/255.0, 238/255.0, 0/255.0, 255/255.0}, {205/255.0, 205/255.0, 0/255.0, 255/255.0}, {139/255.0, 139/255.0, 0/255.0, 255/255.0},
        {255/255.0, 215/255.0, 0/255.0, 255/255.0}, {238/255.0, 201/255.0, 0/255.0, 255/255.0}, {205/255.0, 173/255.0, 0/255.0, 255/255.0},
        {139/255.0, 117/255.0, 0/255.0, 255/255.0}, {255/255.0, 193/255.0, 37/255.0, 255/255.0}, {238/255.0, 180/255.0, 34/255.0, 255/255.0},
        {205/255.0, 155/255.0, 29/255.0, 255/255.0}, {139/255.0, 105/255.0, 20/255.0, 255/255.0}, {255/255.0, 185/255.0, 15/255.0, 255/255.0},
        {238/255.0, 173/255.0, 14/255.0, 255/255.0}, {205/255.0, 149/255.0, 12/255.0, 255/255.0}, {139/255.0, 101/255.0, 8/255.0, 255/255.0},
        {255/255.0, 193/255.0, 193/255.0, 255/255.0}, {238/255.0, 180/255.0, 180/255.0, 255/255.0}, {205/255.0, 155/255.0, 155/255.0, 255/255.0},
        {139/255.0, 105/255.0, 105/255.0, 255/255.0}, {255/255.0, 106/255.0, 106/255.0, 255/255.0}, {238/255.0, 99/255.0, 99/255.0, 255/255.0},
        {205/255.0, 85/255.0, 85/255.0, 255/255.0}, {139/255.0, 58/255.0, 58/255.0, 255/255.0}, {255/255.0, 130/255.0, 71/255.0, 255/255.0},
        {238/255.0, 121/255.0, 66/255.0, 255/255.0}, {205/255.0, 104/255.0, 57/255.0, 255/255.0}, {139/255.0, 71/255.0, 38/255.0, 255/255.0},
        {255/255.0, 211/255.0, 155/255.0, 255/255.0}, {238/255.0, 197/255.0, 145/255.0, 255/255.0}, {205/255.0, 170/255.0, 125/255.0, 255/255.0},
        {139/255.0, 115/255.0, 85/255.0, 255/255.0}, {255/255.0, 231/255.0, 186/255.0, 255/255.0}, {238/255.0, 216/255.0, 174/255.0, 255/255.0},
        {205/255.0, 186/255.0, 150/255.0, 255/255.0}, {139/255.0, 126/255.0, 102/255.0, 255/255.0}, {255/255.0, 165/255.0, 79/255.0, 255/255.0},
        {238/255.0, 154/255.0, 73/255.0, 255/255.0}, {205/255.0, 133/255.0, 63/255.0, 255/255.0}, {139/255.0, 90/255.0, 43/255.0, 255/255.0},
        {255/255.0, 127/255.0, 36/255.0, 255/255.0}, {238/255.0, 118/255.0, 33/255.0, 255/255.0}, {205/255.0, 102/255.0, 29/255.0, 255/255.0},
        {139/255.0, 69/255.0, 19/255.0, 255/255.0}, {255/255.0, 48/255.0, 48/255.0, 255/255.0}, {238/255.0, 44/255.0, 44/255.0, 255/255.0},
        {205/255.0, 38/255.0, 38/255.0, 255/255.0}, {139/255.0, 26/255.0, 26/255.0, 255/255.0}, {255/255.0, 64/255.0, 64/255.0, 255/255.0},
        {238/255.0, 59/255.0, 59/255.0, 255/255.0}, {205/255.0, 51/255.0, 51/255.0, 255/255.0}, {139/255.0, 35/255.0, 35/255.0, 255/255.0},
        {255/255.0, 140/255.0, 105/255.0, 255/255.0}, {238/255.0, 130/255.0, 98/255.0, 255/255.0}, {205/255.0, 112/255.0, 84/255.0, 255/255.0},
        {139/255.0, 76/255.0, 57/255.0, 255/255.0}, {255/255.0, 160/255.0, 122/255.0, 255/255.0}, {238/255.0, 149/255.0, 114/255.0, 255/255.0},
        {205/255.0, 129/255.0, 98/255.0, 255/255.0}, {139/255.0, 87/255.0, 66/255.0, 255/255.0}, {255/255.0, 165/255.0, 0/255.0, 255/255.0},
        {238/255.0, 154/255.0, 0/255.0, 255/255.0}, {205/255.0, 133/255.0, 0/255.0, 255/255.0}, {139/255.0, 90/255.0, 0/255.0, 255/255.0},
        {255/255.0, 127/255.0, 0/255.0, 255/255.0}, {238/255.0, 118/255.0, 0/255.0, 255/255.0}, {205/255.0, 102/255.0, 0/255.0, 255/255.0},
        {139/255.0, 69/255.0, 0/255.0, 255/255.0}, {255/255.0, 114/255.0, 86/255.0, 255/255.0}, {238/255.0, 106/255.0, 80/255.0, 255/255.0},
        {205/255.0, 91/255.0, 69/255.0, 255/255.0}, {139/255.0, 62/255.0, 47/255.0, 255/255.0}, {255/255.0, 99/255.0, 71/255.0, 255/255.0},
        {238/255.0, 92/255.0, 66/255.0, 255/255.0}, {205/255.0, 79/255.0, 57/255.0, 255/255.0}, {139/255.0, 54/255.0, 38/255.0, 255/255.0},
        {255/255.0, 69/255.0, 0/255.0, 255/255.0}, {238/255.0, 64/255.0, 0/255.0, 255/255.0}, {205/255.0, 55/255.0, 0/255.0, 255/255.0},
        {139/255.0, 37/255.0, 0/255.0, 255/255.0}, {255/255.0, 0/255.0, 0/255.0, 255/255.0}, {238/255.0, 0/255.0, 0/255.0, 255/255.0},
        {205/255.0, 0/255.0, 0/255.0, 255/255.0}, {139/255.0, 0/255.0, 0/255.0, 255/255.0}, {255/255.0, 20/255.0, 147/255.0, 255/255.0},
        {238/255.0, 18/255.0, 137/255.0, 255/255.0}, {205/255.0, 16/255.0, 118/255.0, 255/255.0}, {139/255.0, 10/255.0, 80/255.0, 255/255.0},
        {255/255.0, 110/255.0, 180/255.0, 255/255.0}, {238/255.0, 106/255.0, 167/255.0, 255/255.0}, {205/255.0, 96/255.0, 144/255.0, 255/255.0},
        {139/255.0, 58/255.0, 98/255.0, 255/255.0}, {255/255.0, 181/255.0, 197/255.0, 255/255.0}, {238/255.0, 169/255.0, 184/255.0, 255/255.0},
        {205/255.0, 145/255.0, 158/255.0, 255/255.0}, {139/255.0, 99/255.0, 108/255.0, 255/255.0}, {255/255.0, 174/255.0, 185/255.0, 255/255.0},
        {238/255.0, 162/255.0, 173/255.0, 255/255.0}, {205/255.0, 140/255.0, 149/255.0, 255/255.0}, {139/255.0, 95/255.0, 101/255.0, 255/255.0},
        {255/255.0, 130/255.0, 171/255.0, 255/255.0}, {238/255.0, 121/255.0, 159/255.0, 255/255.0}, {205/255.0, 104/255.0, 137/255.0, 255/255.0},
        {139/255.0, 71/255.0, 93/255.0, 255/255.0}, {255/255.0, 52/255.0, 179/255.0, 255/255.0}, {238/255.0, 48/255.0, 167/255.0, 255/255.0},
        {205/255.0, 41/255.0, 144/255.0, 255/255.0}, {139/255.0, 28/255.0, 98/255.0, 255/255.0}, {255/255.0, 62/255.0, 150/255.0, 255/255.0},
        {238/255.0, 58/255.0, 140/255.0, 255/255.0}, {205/255.0, 50/255.0, 120/255.0, 255/255.0}, {139/255.0, 34/255.0, 82/255.0, 255/255.0},
        {255/255.0, 0/255.0, 255/255.0, 255/255.0}, {238/255.0, 0/255.0, 238/255.0, 255/255.0}, {205/255.0, 0/255.0, 205/255.0, 255/255.0},
        {139/255.0, 0/255.0, 139/255.0, 255/255.0}, {255/255.0, 131/255.0, 250/255.0, 255/255.0}, {238/255.0, 122/255.0, 233/255.0, 255/255.0},
        {205/255.0, 105/255.0, 201/255.0, 255/255.0}, {139/255.0, 71/255.0, 137/255.0, 255/255.0}, {255/255.0, 187/255.0, 255/255.0, 255/255.0},
        {238/255.0, 174/255.0, 238/255.0, 255/255.0}, {205/255.0, 150/255.0, 205/255.0, 255/255.0}, {139/255.0, 102/255.0, 139/255.0, 255/255.0},
        {224/255.0, 102/255.0, 255/255.0, 255/255.0}, {209/255.0, 95/255.0, 238/255.0, 255/255.0}, {180/255.0, 82/255.0, 205/255.0, 255/255.0},
        {122/255.0, 55/255.0, 139/255.0, 255/255.0}, {191/255.0, 62/255.0, 255/255.0, 255/255.0}, {178/255.0, 58/255.0, 238/255.0, 255/255.0},
        {154/255.0, 50/255.0, 205/255.0, 255/255.0}, {104/255.0, 34/255.0, 139/255.0, 255/255.0}, {155/255.0, 48/255.0, 255/255.0, 255/255.0},
        {145/255.0, 44/255.0, 238/255.0, 255/255.0}, {125/255.0, 38/255.0, 205/255.0, 255/255.0}, {85/255.0, 26/255.0, 139/255.0, 255/255.0},
        {171/255.0, 130/255.0, 255/255.0, 255/255.0}, {159/255.0, 121/255.0, 238/255.0, 255/255.0}, {137/255.0, 104/255.0, 205/255.0, 255/255.0},
        {93/255.0, 71/255.0, 139/255.0, 255/255.0}, {255/255.0, 225/255.0, 255/255.0, 255/255.0}, {238/255.0, 210/255.0, 238/255.0, 255/255.0},
        {205/255.0, 181/255.0, 205/255.0, 255/255.0}, {139/255.0, 123/255.0, 139/255.0, 255/255.0}, {0/255.0, 0/255.0, 0/255.0, 255/255.0},
        {0/255.0, 0/255.0, 0/255.0, 255/255.0}, {3/255.0, 3/255.0, 3/255.0, 255/255.0}, {3/255.0, 3/255.0, 3/255.0, 255/255.0},
        {5/255.0, 5/255.0, 5/255.0, 255/255.0}, {5/255.0, 5/255.0, 5/255.0, 255/255.0}, {8/255.0, 8/255.0, 8/255.0, 255/255.0},
        {8/255.0, 8/255.0, 8/255.0, 255/255.0}, {10/255.0, 10/255.0, 10/255.0, 255/255.0}, {10/255.0, 10/255.0, 10/255.0, 255/255.0},
        {13/255.0, 13/255.0, 13/255.0, 255/255.0}, {13/255.0, 13/255.0, 13/255.0, 255/255.0}, {15/255.0, 15/255.0, 15/255.0, 255/255.0},
        {15/255.0, 15/255.0, 15/255.0, 255/255.0}, {18/255.0, 18/255.0, 18/255.0, 255/255.0}, {18/255.0, 18/255.0, 18/255.0, 255/255.0},
        {20/255.0, 20/255.0, 20/255.0, 255/255.0}, {20/255.0, 20/255.0, 20/255.0, 255/255.0}, {23/255.0, 23/255.0, 23/255.0, 255/255.0},
        {23/255.0, 23/255.0, 23/255.0, 255/255.0}, {26/255.0, 26/255.0, 26/255.0, 255/255.0}, {26/255.0, 26/255.0, 26/255.0, 255/255.0},
        {28/255.0, 28/255.0, 28/255.0, 255/255.0}, {28/255.0, 28/255.0, 28/255.0, 255/255.0}, {31/255.0, 31/255.0, 31/255.0, 255/255.0},
        {31/255.0, 31/255.0, 31/255.0, 255/255.0}, {33/255.0, 33/255.0, 33/255.0, 255/255.0}, {33/255.0, 33/255.0, 33/255.0, 255/255.0},
        {36/255.0, 36/255.0, 36/255.0, 255/255.0}, {36/255.0, 36/255.0, 36/255.0, 255/255.0}, {38/255.0, 38/255.0, 38/255.0, 255/255.0},
        {38/255.0, 38/255.0, 38/255.0, 255/255.0}, {41/255.0, 41/255.0, 41/255.0, 255/255.0}, {41/255.0, 41/255.0, 41/255.0, 255/255.0},
        {43/255.0, 43/255.0, 43/255.0, 255/255.0}, {43/255.0, 43/255.0, 43/255.0, 255/255.0}, {46/255.0, 46/255.0, 46/255.0, 255/255.0},
        {46/255.0, 46/255.0, 46/255.0, 255/255.0}, {48/255.0, 48/255.0, 48/255.0, 255/255.0}, {48/255.0, 48/255.0, 48/255.0, 255/255.0},
        {51/255.0, 51/255.0, 51/255.0, 255/255.0}, {51/255.0, 51/255.0, 51/255.0, 255/255.0}, {54/255.0, 54/255.0, 54/255.0, 255/255.0},
        {54/255.0, 54/255.0, 54/255.0, 255/255.0}, {56/255.0, 56/255.0, 56/255.0, 255/255.0}, {56/255.0, 56/255.0, 56/255.0, 255/255.0},
        {59/255.0, 59/255.0, 59/255.0, 255/255.0}, {59/255.0, 59/255.0, 59/255.0, 255/255.0}, {61/255.0, 61/255.0, 61/255.0, 255/255.0},
        {61/255.0, 61/255.0, 61/255.0, 255/255.0}, {64/255.0, 64/255.0, 64/255.0, 255/255.0}, {64/255.0, 64/255.0, 64/255.0, 255/255.0},
        {66/255.0, 66/255.0, 66/255.0, 255/255.0}, {66/255.0, 66/255.0, 66/255.0, 255/255.0}, {69/255.0, 69/255.0, 69/255.0, 255/255.0},
        {69/255.0, 69/255.0, 69/255.0, 255/255.0}, {71/255.0, 71/255.0, 71/255.0, 255/255.0}, {71/255.0, 71/255.0, 71/255.0, 255/255.0},
        {74/255.0, 74/255.0, 74/255.0, 255/255.0}, {74/255.0, 74/255.0, 74/255.0, 255/255.0}, {77/255.0, 77/255.0, 77/255.0, 255/255.0},
        {77/255.0, 77/255.0, 77/255.0, 255/255.0}, {79/255.0, 79/255.0, 79/255.0, 255/255.0}, {79/255.0, 79/255.0, 79/255.0, 255/255.0},
        {82/255.0, 82/255.0, 82/255.0, 255/255.0}, {82/255.0, 82/255.0, 82/255.0, 255/255.0}, {84/255.0, 84/255.0, 84/255.0, 255/255.0},
        {84/255.0, 84/255.0, 84/255.0, 255/255.0}, {87/255.0, 87/255.0, 87/255.0, 255/255.0}, {87/255.0, 87/255.0, 87/255.0, 255/255.0},
        {89/255.0, 89/255.0, 89/255.0, 255/255.0}, {89/255.0, 89/255.0, 89/255.0, 255/255.0}, {92/255.0, 92/255.0, 92/255.0, 255/255.0},
        {92/255.0, 92/255.0, 92/255.0, 255/255.0}, {94/255.0, 94/255.0, 94/255.0, 255/255.0}, {94/255.0, 94/255.0, 94/255.0, 255/255.0},
        {97/255.0, 97/255.0, 97/255.0, 255/255.0}, {97/255.0, 97/255.0, 97/255.0, 255/255.0}, {99/255.0, 99/255.0, 99/255.0, 255/255.0},
        {99/255.0, 99/255.0, 99/255.0, 255/255.0}, {102/255.0, 102/255.0, 102/255.0, 255/255.0}, {102/255.0, 102/255.0, 102/255.0, 255/255.0},
        {105/255.0, 105/255.0, 105/255.0, 255/255.0}, {105/255.0, 105/255.0, 105/255.0, 255/255.0}, {107/255.0, 107/255.0, 107/255.0, 255/255.0},
        {107/255.0, 107/255.0, 107/255.0, 255/255.0}, {110/255.0, 110/255.0, 110/255.0, 255/255.0}, {110/255.0, 110/255.0, 110/255.0, 255/255.0},
        {112/255.0, 112/255.0, 112/255.0, 255/255.0}, {112/255.0, 112/255.0, 112/255.0, 255/255.0}, {115/255.0, 115/255.0, 115/255.0, 255/255.0},
        {115/255.0, 115/255.0, 115/255.0, 255/255.0}, {117/255.0, 117/255.0, 117/255.0, 255/255.0}, {117/255.0, 117/255.0, 117/255.0, 255/255.0},
        {120/255.0, 120/255.0, 120/255.0, 255/255.0}, {120/255.0, 120/255.0, 120/255.0, 255/255.0}, {122/255.0, 122/255.0, 122/255.0, 255/255.0},
        {122/255.0, 122/255.0, 122/255.0, 255/255.0}, {125/255.0, 125/255.0, 125/255.0, 255/255.0}, {125/255.0, 125/255.0, 125/255.0, 255/255.0},
        {127/255.0, 127/255.0, 127/255.0, 255/255.0}, {127/255.0, 127/255.0, 127/255.0, 255/255.0}, {130/255.0, 130/255.0, 130/255.0, 255/255.0},
        {130/255.0, 130/255.0, 130/255.0, 255/255.0}, {133/255.0, 133/255.0, 133/255.0, 255/255.0}, {133/255.0, 133/255.0, 133/255.0, 255/255.0},
        {135/255.0, 135/255.0, 135/255.0, 255/255.0}, {135/255.0, 135/255.0, 135/255.0, 255/255.0}, {138/255.0, 138/255.0, 138/255.0, 255/255.0},
        {138/255.0, 138/255.0, 138/255.0, 255/255.0}, {140/255.0, 140/255.0, 140/255.0, 255/255.0}, {140/255.0, 140/255.0, 140/255.0, 255/255.0},
        {143/255.0, 143/255.0, 143/255.0, 255/255.0}, {143/255.0, 143/255.0, 143/255.0, 255/255.0}, {145/255.0, 145/255.0, 145/255.0, 255/255.0},
        {145/255.0, 145/255.0, 145/255.0, 255/255.0}, {148/255.0, 148/255.0, 148/255.0, 255/255.0}, {148/255.0, 148/255.0, 148/255.0, 255/255.0},
        {150/255.0, 150/255.0, 150/255.0, 255/255.0}, {150/255.0, 150/255.0, 150/255.0, 255/255.0}, {153/255.0, 153/255.0, 153/255.0, 255/255.0},
        {153/255.0, 153/255.0, 153/255.0, 255/255.0}, {156/255.0, 156/255.0, 156/255.0, 255/255.0}, {156/255.0, 156/255.0, 156/255.0, 255/255.0},
        {158/255.0, 158/255.0, 158/255.0, 255/255.0}, {158/255.0, 158/255.0, 158/255.0, 255/255.0}, {161/255.0, 161/255.0, 161/255.0, 255/255.0},
        {161/255.0, 161/255.0, 161/255.0, 255/255.0}, {163/255.0, 163/255.0, 163/255.0, 255/255.0}, {163/255.0, 163/255.0, 163/255.0, 255/255.0},
        {166/255.0, 166/255.0, 166/255.0, 255/255.0}, {166/255.0, 166/255.0, 166/255.0, 255/255.0}, {168/255.0, 168/255.0, 168/255.0, 255/255.0},
        {168/255.0, 168/255.0, 168/255.0, 255/255.0}, {171/255.0, 171/255.0, 171/255.0, 255/255.0}, {171/255.0, 171/255.0, 171/255.0, 255/255.0},
        {173/255.0, 173/255.0, 173/255.0, 255/255.0}, {173/255.0, 173/255.0, 173/255.0, 255/255.0}, {176/255.0, 176/255.0, 176/255.0, 255/255.0},
        {176/255.0, 176/255.0, 176/255.0, 255/255.0}, {179/255.0, 179/255.0, 179/255.0, 255/255.0}, {179/255.0, 179/255.0, 179/255.0, 255/255.0},
        {181/255.0, 181/255.0, 181/255.0, 255/255.0}, {181/255.0, 181/255.0, 181/255.0, 255/255.0}, {184/255.0, 184/255.0, 184/255.0, 255/255.0},
        {184/255.0, 184/255.0, 184/255.0, 255/255.0}, {186/255.0, 186/255.0, 186/255.0, 255/255.0}, {186/255.0, 186/255.0, 186/255.0, 255/255.0},
        {189/255.0, 189/255.0, 189/255.0, 255/255.0}, {189/255.0, 189/255.0, 189/255.0, 255/255.0}, {191/255.0, 191/255.0, 191/255.0, 255/255.0},
        {191/255.0, 191/255.0, 191/255.0, 255/255.0}, {194/255.0, 194/255.0, 194/255.0, 255/255.0}, {194/255.0, 194/255.0, 194/255.0, 255/255.0},
        {196/255.0, 196/255.0, 196/255.0, 255/255.0}, {196/255.0, 196/255.0, 196/255.0, 255/255.0}, {199/255.0, 199/255.0, 199/255.0, 255/255.0},
        {199/255.0, 199/255.0, 199/255.0, 255/255.0}, {201/255.0, 201/255.0, 201/255.0, 255/255.0}, {201/255.0, 201/255.0, 201/255.0, 255/255.0},
        {204/255.0, 204/255.0, 204/255.0, 255/255.0}, {204/255.0, 204/255.0, 204/255.0, 255/255.0}, {207/255.0, 207/255.0, 207/255.0, 255/255.0},
        {207/255.0, 207/255.0, 207/255.0, 255/255.0}, {209/255.0, 209/255.0, 209/255.0, 255/255.0}, {209/255.0, 209/255.0, 209/255.0, 255/255.0},
        {212/255.0, 212/255.0, 212/255.0, 255/255.0}, {212/255.0, 212/255.0, 212/255.0, 255/255.0}, {214/255.0, 214/255.0, 214/255.0, 255/255.0},
        {214/255.0, 214/255.0, 214/255.0, 255/255.0}, {217/255.0, 217/255.0, 217/255.0, 255/255.0}, {217/255.0, 217/255.0, 217/255.0, 255/255.0},
        {219/255.0, 219/255.0, 219/255.0, 255/255.0}, {219/255.0, 219/255.0, 219/255.0, 255/255.0}, {222/255.0, 222/255.0, 222/255.0, 255/255.0},
        {222/255.0, 222/255.0, 222/255.0, 255/255.0}, {224/255.0, 224/255.0, 224/255.0, 255/255.0}, {224/255.0, 224/255.0, 224/255.0, 255/255.0},
        {227/255.0, 227/255.0, 227/255.0, 255/255.0}, {227/255.0, 227/255.0, 227/255.0, 255/255.0}, {229/255.0, 229/255.0, 229/255.0, 255/255.0},
        {229/255.0, 229/255.0, 229/255.0, 255/255.0}, {232/255.0, 232/255.0, 232/255.0, 255/255.0}, {232/255.0, 232/255.0, 232/255.0, 255/255.0},
        {235/255.0, 235/255.0, 235/255.0, 255/255.0}, {235/255.0, 235/255.0, 235/255.0, 255/255.0}, {237/255.0, 237/255.0, 237/255.0, 255/255.0},
        {237/255.0, 237/255.0, 237/255.0, 255/255.0}, {240/255.0, 240/255.0, 240/255.0, 255/255.0}, {240/255.0, 240/255.0, 240/255.0, 255/255.0},
        {242/255.0, 242/255.0, 242/255.0, 255/255.0}, {242/255.0, 242/255.0, 242/255.0, 255/255.0}, {245/255.0, 245/255.0, 245/255.0, 255/255.0},
        {245/255.0, 245/255.0, 245/255.0, 255/255.0}, {247/255.0, 247/255.0, 247/255.0, 255/255.0}, {247/255.0, 247/255.0, 247/255.0, 255/255.0},
        {250/255.0, 250/255.0, 250/255.0, 255/255.0}, {250/255.0, 250/255.0, 250/255.0, 255/255.0}, {252/255.0, 252/255.0, 252/255.0, 255/255.0},
        {252/255.0, 252/255.0, 252/255.0, 255/255.0}, {255/255.0, 255/255.0, 255/255.0, 255/255.0}, {255/255.0, 255/255.0, 255/255.0, 255/255.0},
        {169/255.0, 169/255.0, 169/255.0, 255/255.0}, {169/255.0, 169/255.0, 169/255.0, 255/255.0}, {0/255.0, 0/255.0, 139/255.0, 255/255.0},
        {0/255.0, 139/255.0, 139/255.0, 255/255.0}, {139/255.0, 0/255.0, 139/255.0, 255/255.0}, {139/255.0, 0/255.0, 0/255.0, 255/255.0},
        {144/255.0, 238/255.0, 144/255.0, 255/255.0},
        
        /*{0,0,0,0}, {0,0,0,0}, {0,0,0,0}, {0,0,0,0}, {0,0,0,0},*/ {0,0,0,0}
    };
    
/*
 * This can be used to change the number of items per line in the
 * above table.
 */
/*void _genColors(void)
{
    size_t numline = 3;
    size_t i, j;
    for(j = 0; j < _sg_colNum / numline + (_sg_colNum % numline ? 1 : 0); j++)
    {
        for(i = j * numline; i < j * numline + numline && i < _sg_colNum; i++)
            printf(" \"%s\",", _sg_colNames[i]);
        for(i = j * numline; i < j * numline + numline && i < _sg_colNum; i++)
            printf(" %u,", _sg_colFlags[i]);
        for(i = j * numline; i < j * numline + numline && i < _sg_colNum; i++)
            printf(" {%g/255.0, %g/255.0, %g/255.0, %g/255.0},",
                _sg_colValues[i].r * 255, _sg_colValues[i].g * 255,
                _sg_colValues[i].b * 255, _sg_colValues[i].a * 255);
        printf("\n");
    }
}*/

void SG_EXPORT _sgColorPreprocess(char* buf, size_t buflen, const char* name)
{
    size_t i, j;
    for(i = 0, j = 0; name[i] && (j < (buflen - 1)); i++)
    {
        if(name[i] == ' ')
            continue;
        buf[j] = tolower(name[i]);

        j++;
    }
    buf[j] = 0;
}
SGColor SG_EXPORT _sgColorValue(const char* name, SGubyte flag)
{
    char buf[256];
    size_t i;

    for(i = 0; i < _sg_colNum; i++)
    {
        if(!(_sg_colFlags[i] & flag))
            continue;

        // can be removed once the colors above are filtered
        _sgColorPreprocess(buf, sizeof(buf), _sg_colNames[i]);

        if(strcmp(name, buf) == 0)
            return _sg_colValues[i];
    }

    return sgColorNan();
}

SGColor SG_EXPORT sgColor4f(float r, float g, float b, float a)
{
    SGColor c;
    c.r = r; c.g = g; c.b = b; c.a = a;
    return c;
}
SGColor SG_EXPORT sgColor3f(float r, float g, float b)
{
    return sgColor4f(r, g, b, 1.0);
}
SGColor SG_EXPORT sgColor2f(float g, float a)
{
    return sgColor4f(g, g, g, a);
}
SGColor SG_EXPORT sgColor1f(float g)
{
    return sgColor4f(g, g, g, 1.0);
}
SGColor SG_EXPORT sgColor4fv(float* rgba)
{
    return sgColor4f(rgba[0], rgba[1], rgba[2], rgba[3]);
}
SGColor SG_EXPORT sgColor3fv(float* rgb)
{
    return sgColor3f(rgb[0], rgb[1], rgb[2]);
}
SGColor SG_EXPORT sgColor2fv(float* ga)
{
    return sgColor2f(ga[0], ga[1]);
}
SGColor SG_EXPORT sgColor1fv(float* g)
{
    return sgColor1f(g[0]);
}
SGColor SG_EXPORT sgColor4ub(SGubyte r, SGubyte g, SGubyte b, SGubyte a)
{
    return sgColor4f(r / 255.0, g / 255.0, b / 255.0, a / 255.0);
}
SGColor SG_EXPORT sgColor3ub(SGubyte r, SGubyte g, SGubyte b)
{
    return sgColor4ub(r, g, b, 255);
}
SGColor SG_EXPORT sgColor2ub(SGubyte g, SGubyte a)
{
    return sgColor4ub(g, g, g, a);
}
SGColor SG_EXPORT sgColor1ub(SGubyte g)
{
    return sgColor4ub(g, g, g, 255);
}
SGColor SG_EXPORT sgColor4ubv(SGubyte* rgba)
{
    return sgColor4ub(rgba[0], rgba[1], rgba[2], rgba[3]);
}
SGColor SG_EXPORT sgColor3ubv(SGubyte* rgb)
{
    return sgColor3ub(rgb[0], rgb[1], rgb[2]);
}
SGColor SG_EXPORT sgColor2ubv(SGubyte* ga)
{
    return sgColor2ub(ga[0], ga[1]);
}
SGColor SG_EXPORT sgColor1ubv(SGubyte* g)
{
    return sgColor1ub(g[0]);
}
SGColor SG_EXPORT sgColorRGBA(SGuint color)
{
    return sgColor4ub(color >> 24, color >> 16, color >> 8, color);
}
SGColor SG_EXPORT sgColorBGRA(SGuint color)
{
    return sgColor4ub(color >> 8, color >> 16, color >> 24, color);
}
SGColor SG_EXPORT sgColorARGB(SGuint color)
{
    return sgColor4ub(color >> 16, color >> 8, color, color >> 24);
}
SGColor SG_EXPORT sgColorABGR(SGuint color)
{
    return sgColor4ub(color, color >> 8, color >> 16, color >> 24);
}
SGColor SG_EXPORT sgColorRGB(SGuint color)
{
    return sgColor4ub(color >> 16, color >> 8, color, 255);
}
SGColor SG_EXPORT sgColorBGR(SGuint color)
{
    return sgColor4ub(color, color >> 8, color >> 16, 255);
}
SGColor SG_EXPORT sgColorX11(const char* name)
{
    char bufn[256];
    _sgColorPreprocess(bufn, sizeof(bufn), name);

    // special cases
    if(strcmp(bufn, "gray") == 0)
        return sgColor3ub(190, 190, 190);
    else if(strcmp(bufn, "grey") == 0)
        return sgColor3ub(190, 190, 190);
    else if(strcmp(bufn, "green") == 0)
        return sgColor3ub(0, 255, 0);
    else if(strcmp(bufn, "maroon") == 0)
        return sgColor3ub(176, 48, 96);
    else if(strcmp(bufn, "purple") == 0)
        return sgColor3ub(160, 32, 240);

    return _sgColorValue(bufn, 1);
}
SGColor SG_EXPORT sgColorWeb(const char* name)
{
    char bufn[256];
    _sgColorPreprocess(bufn, sizeof(bufn), name);

    // special cases
    if(strcmp(bufn, "gray") == 0)
        return sgColor3ub(127, 127, 127);
    else if(strcmp(bufn, "grey") == 0)
        return sgColor3ub(127, 127, 127);
    else if(strcmp(bufn, "green") == 0)
        return sgColor3ub(0, 127, 0);
    else if(strcmp(bufn, "maroon") == 0)
        return sgColor3ub(127, 0, 0);
    else if(strcmp(bufn, "purple") == 0)
        return sgColor3ub(127, 0, 127);

    return _sgColorValue(bufn, 2);
}
SGColor SG_EXPORT sgColorNan(void)
{
    return sgColor4f(SG_NAN, SG_NAN, SG_NAN, SG_NAN);
}

SGbool SG_EXPORT sgColorIsNan(SGColor c)
{
    return (c.r != c.r) || (c.g != c.g) || (c.b != c.b) || (c.a != c.a);
}

SGColor SG_EXPORT sgColorMix(SGColor a, SGColor b, float t)
{
    return sgColor4f(a.r + t * (b.r - a.r),
                     a.g + t * (b.g - a.g),
                     a.b + t * (b.b - a.b),
                     a.a + t * (b.a - a.a));
}
SGColor SG_EXPORT sgColorAdd1c(SGColor a, SGColor b)
{
    return sgColor4f(a.r + b.r,
                     a.g + b.g,
                     a.b + b.b,
                     a.a + b.a);
}
SGColor SG_EXPORT sgColorSub1c(SGColor a, SGColor b)
{
    return sgColor4f(a.r - b.r,
                     a.g - b.g,
                     a.b - b.b,
                     a.a - b.a);
}
SGColor SG_EXPORT sgColorMul1c(SGColor a, SGColor b)
{
    return sgColor4f(a.r * b.r,
                     a.g * b.g,
                     a.b * b.b,
                     a.a * b.a);
}
SGColor SG_EXPORT sgColorDiv1c(SGColor a, SGColor b)
{
    return sgColor4f(a.r / b.r,
                     a.g / b.g,
                     a.b / b.b,
                     a.a / b.a);
}

void SG_EXPORT sgColorTo4ub(SGColor c, SGubyte* r, SGubyte* g, SGubyte* b, SGubyte* a)
{
	SGubyte tmp;
	if(!r) r = &tmp;
	if(!g) g = &tmp;
	if(!b) b = &tmp;
	if(!a) a = &tmp;
	
	*r = (SGubyte)(c.r * 255.0);
	*g = (SGubyte)(c.g * 255.0);
	*b = (SGubyte)(c.b * 255.0);
	*a = (SGubyte)(c.a * 255.0);
}
void SG_EXPORT sgColorTo4ubv(SGColor c, SGubyte* rgba)
{
	sgColorTo4ub(c, &rgba[0], &rgba[1], &rgba[2], &rgba[3]);
}
